MAXScript Extensions > MAXScript Extensions for character studio > Biped MAXScript Extensions > Biped Keys >

# BipedKey : MAXObject

| Character Studio - Quick Navigation

All Biped vertical, horizontal, turning, and body keys are represented by this class.

Properties

    <bipedkey>.time Time Default: Varies

When in time the key occurs.

    <bipedkey>.selected Boolean Default: False

True if the key is selected.

    <bipedkey>.tension Float Default: 25.0

Controls the amount of curvature in the animation curve.

High Tension produces a linear curve. It also has a slight Ease To and Ease From effect.

Low Tension produces a very wide, rounded, curve. It also has a slight negative Ease To and Ease From effect

    <bipedkey>.continuity Float Default: 25.0

Controls the tangential property of the curve at the key. The default setting is the only value that produces a smooth animation curve through the key. All other values produce a discontinuity in the animation curve causing an abrupt change in the animation.

    <bipedkey>.bias Float Default: 25.0

Controls where the animation curve occurs with respect to the key.

    <bipedkey>.easeTo Float Default: 0.0

Slows the velocity of the animation curve as it approaches the key.

High Ease To causes the animation to decelerate as it approaches the key.

The default setting causes no extra deceleration.

    <bipedkey>.easeFrom Float Default: 0.0

Slows the velocity of the animation curve as it leaves the key.

High Ease From causes the animation to start slow and accelerate as it leaves the key.

The default setting causes no change of the animation curve.

    <bipedkey>.type Name Default: Varies -- Read-only

Contains #vertical, #horizontal, #turning, #body, #biped, #head, or #prop, based on the key type.

There are additional properties based on the type of the key:

## #vertical

    <vertkey>.z Float Default: Varies

Position of the selected biped part in z.

    <vertkey>.dynamicsBlend Float Default: 1.0

Controls the amount of gravity in an airborne period, as in a running or jumping motion. This parameter has no effect on a walking motion where footsteps overlap.

    <vertkey>.ballisticTension Float Default: 0.5

Controls the amount of spring or tension when the biped lands or takes off from a jump or run step. The change is subtle.

A walk cycle will not activate this value. The biped has to be airborne, thenthe Lift and Touch vertical keys will display a Ballistic Tension value.

## #horizontal

    <horzkey>.x Float Default: Varies

Position of the selected biped part in x.

    <horzkey>.y Float Default: Varies

Position of the selected biped part in y.

    <horzkey>.balanceFactor Float Default: 1.0

Positions the biped's weight along a line that extends from the center of mass to the biped's head. A value of 0 places the biped's weight at the center of mass. A value of 1 places the biped's weight above the center of mass. A value of 2 places the biped's weight in the head.

## #turning

    <turnkey>.rotation Quaternion Default: (quat 0 0 0 1)

Rotation of the selected biped part.

## #body

    <bodykey>.ikBlend Float Default: 0.0

Determines how forward kinematics and inverse kinematics are blended to interpolate an intermediate position.

    <bodykey>.ikSpace Integer Default: 0 0 - Body

The biped limb is in biped coordinate space.

    1 - Object

The biped limb is either in World coordinate space or the coordinate space of the selected object. Coordinate space can be blended between keys.

    <bodykey>.ikAnkleTension Float Default: 0.0

Adjusts the precedence of the ankle joint over the knee joint. When set to 0, the knee takes precedence. When set to 1, the ankle takes precedence.

    <bodykey>.ikJoinedPivot Boolean Default: True

Put the biped foot in the coordinate space of the previous key.

    <bodykey>.ikPivotIndex Integer Default: 1

Index into <bodykey>.ikPivots array of active (selected) pivot

    <bodykey>.ikNumPivots Integer Default: Varies -- Read-only

Number of pivot points in <bodykey>.ikPivots array

    <bodykey>.ikPivots Array Deafult: Varies -- Array of Point3 values

Array of positions of all the pivot points for the body part

## #biped

#biped type keys do not expose any additional parameters

## #head

    <headkey>.headBlend Float Default: 0.0

Determines the degree of influence of the lookat target (headObject) on the head's rotation. At a value of 0, the headObject's position has no influence on the head's rotation. At a value of 1, the head will look at the headObject.

## #prop

    <propkey>.posSpace Integer Default: 1
    <propkey>.rotSpace Integer Default: varies

0 - World - Positioning/rotation is in world coordinate space.

1 - Body - Positioning/rotation is in body coordinate space.

2 - Right Hand - Positioning/rotation is in right hand coordinate space.

3 - Left Hand - Positioning/rotation is in left hand coordinate space.

EXAMPLE
    -- to add a new key
    k = biped.addNewKey $'bip01 L clavicle'.controller 10f
    k = biped.getKey $'bip01 L clavicle'.controller 1
    showProperties k
    k.ikBlend = .5
    k.ikSpace = 0
    k.ikAnkleTension = .8
    k.ikJoinedPivot = false
    k.ikPivotIndex = 8
    k.ikNumPivots
    k.ikPivots

#### See Also

- BipedFSKey : MAXObject

- MAXScript Extensions in character studio